//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <ShellApi.h>
#include "pou1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
#include <stdio.h>
#include <math.h>
TForm1 *Form1;

float my_input(TEdit *EditX,int min,int max);
void  my_raschet(void);
void  my_refresh(void);
void  my_about(void);
void  my_save(void);
void  my_load(void);
void  my_out(void);
int  my_RTM(void);

FILE *f;
struct dano
       {
         float V1;
         float ni;
         float krat;
         float tH;
         float TH;
         float TK;
         float P;
         float dP[3];
         float delta[3];
         float K[3];
       };
struct TOO
       {
          float F1;
          float de;
          float f1;
          float Lp;
          float Du;
          float aturb;
          float alam;
          float F[16];
          float N[16];
          float M[16];
       };

static TOO GOST [4]={
  {0.2,0.0088,0.00178,0.518,0.15,0.065,0.46,
       {1,2,5,6.3,10,12.5,16,25,31.5,40},
       {8,12,28,34,52,66,84,128,160,204},
       {570,590,650,670,750,800,1340,1480,1600,1750}},
  {0.3,0.0080,0.00110,1.12,0.065,0.1,0.6,
       {3,5,8,10,12.5,16,20},
       {12,20,30,36,44,56,70},
       {280,315,345,365,400,440,485}},
  {0.6,0.0083,0.00245,1.01,0.2,0.135,0.6,
       {10,16,25,31.5,40,50,63,80,100,140,160,200,250,300},
       {20,30,44,56,70,86,108,136,170,236,270,340,420,504},
       {960,1030,1130,1220,1300,1400,1530,1690,1900,2290,2470,3920,4400,4890}},
  {1.3,0.0096,0.00425,1.47,0.3,0.135,0.6,
       {200,300,400,500,600,800},
       {156,232,310,388,464,620},
       {5350,6470,7610,11280,12430,14740}}
  }, plast;

dano id={10,85.9,7,10,120,80,350000,{0,105000,300000},{0,0.00024,0.00014},{0,1000,1000}};

float n,tK,tCT,
      tCP[4],ro[4],mu[4],nu[4],c[4],lambda[4],G[3],V[3],Q,
      lambdaCTEH,dtCP,K,zeta[3],W[3],Re[3],Re_lim=50,
      Pr[4],PrCT,Nu[3],Fa,F,alfa[3],
      fp[3],m[3],nn[3],Fp[3],X[3],
      fp_[3],W_[3],Re_[3],Nu_[3],alfa_[3],F_,dF,K_,
      zeta_[3],dP[3],Wsh[3],PI=3.1415,ddP[3];

int N,Nplast;


//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------


int  my_RTM(void)
{
  n=id.ni/(1+id.krat);
  tK=id.tH-1;
  while (1)
  {
    if(tK>1000) return 0;
    tCP[1]=(id.TH+id.TK)/2;
    tCP[2]=(id.tH+tK)/2;
    tCP[3]=(tCP[1]+tCP[2])/2;  // ..
    for(int i=1;i<4;i++)      //   
    {
      ro[i]=1007.30+4.11*(30.03+n-0.11*(tCP[i]+273));
      mu[i]=((2.7+0.192*n)*pow(tCP[i],-0.426))/1000;
      nu[i]=mu[i]/ro[i];
      c[i]=(3.707-0.00134*(14.4*n-tCP[i]+273))*1000;
      lambda[i]=0.5646*pow(tCP[i],0.0879)*pow(n,-0.135);
    }

    lambdaCTEH=15.873;

    G[1]=(id.V1*ro[1])/3600;
    V[1]=id.V1;
//************************  ר: ************************************
    Q=G[1]*c[1]*(id.TH-id.TK);
    G[2]=Q/(c[2]*(tK-id.tH));
    if(fabs((G[2]-G[1])/G[1])<=0.0001)break;
    tK+=fabs((G[2]-G[1])/G[1])/2;
  }
  V[2]=3600*G[2]/ro[2];
  dtCP=(((id.TH-tK)-(id.TK-id.tH)))/log(fabs(id.TH-tK)/fabs(id.TK-id.tH));
  Nplast=-1;
NEXT_PLAST:                   //    
  Nplast++;
  if(Nplast>3) return 0;
  /*{
          Application->MessageBoxA("   "
                                   " !\n,"
                                   "    .",
                                   "       !    "
                                   "!",MB_OK); return;}
  */

    if(Form1->ComboBox1->ItemIndex<4)plast=GOST[Form1->ComboBox1->ItemIndex];
    else plast=GOST[Nplast];
    for(int i=1;i<3;i++)      //   
    {
      zeta[i]=0.1;
      float zeta_buf;
      while(1)
      {
        W[i]=2*pow((id.K[i]*dtCP*id.dP[i])/(c[i]*(id.TH-id.TK)*ro[i]*ro[i]*zeta[i]),1./3.);
        Re[i]=W[i]*plast.de/nu[i];
        if(Re[i]<Re_lim) zeta_buf=425/Re[i];
        else zeta_buf=19.6/pow(Re[i],0.25);
        if(fabs(zeta[i]-zeta_buf)<0.01)break;
        zeta[i]+=(zeta_buf-zeta[i])/zeta_buf;
      }
      Pr[i]=(c[i]*nu[i]*ro[i])/(lambda[i]);
      Pr[3]=(c[3]*nu[3]*ro[3])/(lambda[3]);
      if(Re[i]<Re_lim)
         Nu[i]=plast.alam*pow(Re[i],0.33)*pow(Pr[i],0.33)*pow(Pr[i]/Pr[3],0.25);
      else Nu[i]=plast.aturb*pow(Re[i],0.73)*pow(Pr[i],0.43)*pow(Pr[i]/Pr[3],0.25);
      alfa[i]=(Nu[i]*lambda[i])/plast.de;
    }
  K=1/(1/alfa[1]+1/alfa[2]+id.delta[1]/lambda[1]+id.delta[2]/lambda[2]+
     0.001/lambdaCTEH);
  F=Q/(K*dtCP);
  N=-1;
  for(int i=0;i<15;i++)
  {
    if((plast.F[i]-F)/F>-0.04) {N=i; Fa=plast.F[i]; break;}
    if(plast.F[i]==0 && Form1->ComboBox1->ItemIndex<4) {N=i-1; Fa=plast.F[i-1]; break;}
  }
  if(Form1->ComboBox1->ItemIndex==4 && N==-1) goto NEXT_PLAST;
//************************  ר: *****************************
    for(int i=1;i<3;i++)      //   
    {
      fp[i]=V[i]/(3600.*W[i]);
      m[i]=fp[i]/plast.f1;
      m[i]=ceill(m[i]);  //  :     m[i]
      nn[i]=m[i]+m[i];
      Fp[i]=plast.F1*nn[i];
      X[i]=Fa/Fp[i];
      X[i]=ceill(X[i]);  //  :     X[i]
      fp_[i]=plast.f1*m[i];
      W_[i]=G[i]/(ro[i]*fp_[i]);
      Re_[i]=(W_[i]*plast.de)/nu[i];
      if(Re_[i]<Re_lim)
         Nu_[i]=plast.alam*pow(Re_[i],0.33)*pow(Pr[i],0.33)*pow(Pr[i]/Pr[3],0.25);
      else Nu_[i]=plast.aturb*pow(Re_[i],0.73)*pow(Pr[i],0.43)*pow(Pr[i]/Pr[3],0.25);
      alfa_[i]=(Nu_[i]*lambda[i])/plast.de;
    }
  K_=1/(1/alfa_[1]+1/alfa_[2]+id.delta[1]/lambda[1]+id.delta[2]/lambda[2]+
     0.001/lambdaCTEH);
  F_=Q/(K_*dtCP);
  dF=((Fa-F_)*100)/F_;
  if(dF<-5 && Form1->ComboBox1->ItemIndex==4)goto NEXT_PLAST;
//************************  ר: **************************
  for(int i=1;i<3;i++)      //   
  {
    zeta_[i]=19.6/pow(Re[i],0.25);
    dP[i]=zeta_[i]*(plast.Lp/plast.de)*ro[i]*(pow(W_[i],2)/2)*X[i];
    Wsh[i]=4*V[i]/(3600*PI*plast.Du*plast.Du);
    ddP[i]=(id.dP[i]-dP[i])*100/dP[i];
    if(ddP[i]<-5 && Form1->ComboBox1->ItemIndex==4)goto NEXT_PLAST;
  }
  return 1;
}
//---------------------------------------------------------------------------


void  my_out(void)
{
  TStringList *rez = new TStringList;
  rez->Add("-----------                     ----------");
  rez->Add("-----------------------------------------------------------------");
  rez->Add("1.    ");
  rez->Add(" 1.1.    :  "+
            FloatToStrF(id.V1,ffFixed,3,3)+" ../.");
  rez->Add(" 1.2.  ( )     :  "+
            FloatToStrF(id.ni,ffFixed,3,3)+" %.");
  rez->Add(" 1.3.   ( )"
           "  :  1   "+
            FloatToStrF(id.krat,ffFixed,3,3)+"  .");
  rez->Add(" 1.4.        :  "+
            FloatToStrF(id.tH,ffFixed,3,3)+"  .");
  rez->Add(" 1.5.        :  "+
            FloatToStrF(tK,ffFixed,3,3)+"  .");
  rez->Add(" 1.6.   , "
           "   :  "+
            FloatToStrF(id.TH,ffFixed,3,3)+"  .");
  rez->Add(" 1.7.       :  "+
            FloatToStrF(id.TK,ffFixed,3,3)+"  .");
  rez->Add(" 1.8.    :  "+
            FloatToStrF(id.P,ffFixed,10,3)+" .");
  rez->Add(" 1.9.     "
           "   :  "+
            FloatToStrF(id.dP[1],ffFixed,10,3)+" .");
  rez->Add(" 1.10.     "
           "  :  "+
            FloatToStrF(id.dP[2],ffFixed,10,3)+" .");
  rez->Add(" 1.11.      "
           "  :  "+
            FloatToStrF(id.delta[1],ffFixed,3,7)+" .");
  rez->Add(" 1.12.     "
           "  :  "+
            FloatToStrF(id.delta[2],ffFixed,3,7)+" .");
  rez->Add(" 1.13.   :");
  rez->Add("  1.13.1       "
           " "+FloatToStrF(tCP[1],ffFixed,7,3)+" . ");
  for(int i=1;i<4;i++)
  {
    if(i==2) rez->Add("  1.13.2       "
                      " "+FloatToStrF(tCP[i],ffFixed,7,3)+
                      " . ");
    if(i==3) rez->Add("  1.13.3.       "+
                     FloatToStrF(tCP[3],ffFixed,7,3)+" . ");
    rez->Add("   1.13."+IntToStr(i)+".1 : "+
            FloatToStrF(ro[2],ffFixed,7,3)+" /..");
    rez->Add("   1.13."+IntToStr(i)+".2.  : "+
            FloatToStrF(c[i],ffFixed,7,3)+" /( ).");
    rez->Add("   1.13."+IntToStr(i)+".3.  : "+
            FloatToStrF(lambda[i],ffFixed,7,3)+" /( ).");
    rez->Add("   1.13."+IntToStr(i)+".4.  : "+
            FloatToStrF(nu[i],ffFixed,7,10)+" ./.");
  }

  rez->Add("-----------------------------------------------------------------");
  rez->Add("2.   ");
  rez->Add(" 2.1.  ,    :  "+
           FloatToStrF(Q,ffFixed,7,3)+" .");
  rez->Add(" 2.2.    :  "+
           FloatToStrF(G[2],ffFixed,7,3)+" /.");
  rez->Add(" 2.3.   :  "+
           FloatToStrF(dtCP,ffFixed,7,3)+" ..");
  rez->Add(" 2.4.      :");
  for(int i=1;i<3;i++)
  {
    if(i==2) rez->Add(" 2.5.      :");
    rez->Add("  2."+IntToStr(3+i)+".1.    "
             ":  "+FloatToStrF(id.K[i],ffFixed,7,3)+" /(.. ).");
    rez->Add("  2."+IntToStr(3+i)+".2.    "
             "   :  "+
            FloatToStrF(zeta[i],ffFixed,7,3));
    rez->Add("  2."+IntToStr(3+i)+".3.    "
             " :  "+FloatToStrF(W[i],ffFixed,7,3)+" /.");
    rez->Add("  2."+IntToStr(3+i)+".4.  :  "+
            FloatToStrF(Re[i],ffFixed,7,3));
    rez->Add("  2."+IntToStr(3+i)+".5.   (  "
             "   "+FloatToStrF(tCP[i],ffFixed,7,3)+
             " .):  "+FloatToStrF(Pr[i],ffFixed,7,3));
    rez->Add("  2."+IntToStr(3+i)+".6.      "
             "(   "+FloatToStrF(tCP[3],ffFixed,7,3)+
             " .):  "+FloatToStrF(Pr[3],ffFixed,7,3));
    rez->Add("  2."+IntToStr(3+i)+".7.  :  "+
            FloatToStrF(Nu[i],ffFixed,7,3));
    rez->Add("  2."+IntToStr(3+i)+".8.     "
             "  :  "+FloatToStrF(alfa[i],ffFixed,7,3)+"/(.. )");
  }
  rez->Add(" 2.6.  :  "+FloatToStrF(K,ffFixed,7,3));
  rez->Add(" 2.7.    :  "+
          FloatToStrF(F,ffFixed,7,3)+" ..");
  rez->Add(" 2.8.       "
           " :  "+FloatToStrF(Fa,ffFixed,7,3));
  rez->Add("-----------------------------------------------------------------");
  rez->Add("3.   ");
  rez->Add(" 3.1.      :");
  for(int i=1;i<3;i++)
  {
    if(i==2) rez->Add(" 3.2.      :");
    rez->Add("  3."+IntToStr(i)+".1.    :  "+
            FloatToStrF(fp[i],ffFixed,7,6)+" ..");
    rez->Add("  3."+IntToStr(i)+".2.     :  "+
            FloatToStrF(m[i],ffFixed,7,0)+" .");
    rez->Add("  3."+IntToStr(i)+".3.     :  "+
            FloatToStrF(nn[i],ffFixed,7,0)+" .");
    rez->Add("  3."+IntToStr(i)+".4.    "
             " :  "+FloatToStrF(Fp[i],ffFixed,7,3)+" ..");
    rez->Add("  3."+IntToStr(i)+".5.   ()  :  "+
            FloatToStrF(X[i],ffFixed,7,0)+" .");
  }
  rez->Add(" 3.3.    :  "+
  FloatToStrF(plast.N[N],ffFixed,7,0)+" .");
  rez->Add("         ");
  rez->Add("       :");
  rez->Add(" 3.4       :");
  for(int i=1;i<3;i++)
  {
    if(i==2) rez->Add(" 3.5.      :");
    rez->Add("  2."+IntToStr(3+i)+".1.     "
             "  :  "+FloatToStrF(fp_[i],ffFixed,7,6)+" ..");
    rez->Add("  2."+IntToStr(3+i)+".2.    "
             " :  "+FloatToStrF(W_[i],ffFixed,7,3)+" /.");
    rez->Add("  2."+IntToStr(3+i)+".3.  :  "+
            FloatToStrF(Re_[i],ffFixed,7,3));
    rez->Add("  2."+IntToStr(3+i)+".4.  :  "+
            FloatToStrF(Nu_[i],ffFixed,7,3));
    rez->Add("  2."+IntToStr(3+i)+".5.     "
             "  :  "+FloatToStrF(alfa_[i],ffFixed,7,3)+"/(.. )");
  }
  rez->Add(" 3.6.  :  "+
          FloatToStrF(K_,ffFixed,7,3)+"/(.. )");
  rez->Add(" 3.7.    :  "+
          FloatToStrF(F_,ffFixed,7,3)+" ..");
  rez->Add(" 3.8.    :  "+FloatToStrF(dF,ffFixed,7,3)+" %");
  rez->Add("-----------------------------------------------------------------");
  rez->Add("4.   ");
  rez->Add(" 4.1       :");
  for(int i=1;i<3;i++)
  {
    if(i==2) rez->Add(" 4.2.      :");
    rez->Add("  4."+IntToStr(i)+".1.    "
             "    :  "+
            FloatToStrF(zeta_[i],ffFixed,7,3));
    rez->Add("  4."+IntToStr(i)+".2.    "
             ":  "+FloatToStrF(dP[i],ffFixed,7,3)+" .");
    rez->Add("  4."+IntToStr(i)+".3.    "
             " :  "+FloatToStrF(Wsh[i],ffFixed,7,3)+" /.");
    rez->Add("  5."+IntToStr(i)+".4.    :  "+
            FloatToStrF(ddP[i],ffFixed,7,3)+" %.");
  }
  rez->Add("-----------------------------------------------------------------");
  rez->Add("-----------------------------------------------------------------");
  rez->Add("5.     :");
  rez->Add(" 5.1.  :  "+FloatToStrF(plast.F1,ffFixed,7,1)+" ..");
  rez->Add(" 5.2.  :  "+
          FloatToStrF(plast.F[N],ffFixed,7,1)+" ..");
  rez->Add(" 5.3.  :  "+FloatToStrF(plast.N[N],ffFixed,7,0)+" .");
  rez->Add(" 5.4.  :  "+FloatToStrF(plast.M[N],ffFixed,7,0)+" .");
  Form1->Memo1->Lines=rez;
}
//---------------------------------------------------------------------------


void  my_raschet(void)
{
if(my_RTM()==0)
  {
    Application->MessageBoxA("    "
                             " !\n,"
                             "    .  "
                             "  ",
                             "       !    "
                             " !",MB_OK);
    return;
  }
  Form1->Memo1->Visible=!Form1->Memo1->Visible;
  Form1->GroupBox1->Visible=!Form1->GroupBox1->Visible;
  Form1->SpeedButton1->Visible=!Form1->SpeedButton1->Visible;
  if(Form1->Memo1->Visible)
  {
    Form1->GroupBox2->Visible=false;
    Form1->WindowState=wsMaximized;
    Form1->N17->Caption="     !";
  }
  else
  {
    Form1->WindowState=wsNormal;
    Form1->N17->Caption="          !";
    return;
  }
  my_out();
}
//---------------------------------------------------------------------------

float my_input(TEdit *EditX,int min,int max)
{
     float x=0;
     try {x=StrToFloat(EditX->Text);}
     catch (EConvertError&)
     {
       Beep();
       Application->MessageBoxA(" !\n"
                                ",  .",
                                "       !   !",MB_OK);

       EditX->SetFocus();
     }
     if(x<min || x>max)
     {
         Beep();
         Application->MessageBoxA("    !\n"
                                  ",  .",
                                  "       !   !",MB_OK);
         EditX->SetFocus();
     }
     return x;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ApplicationEvents1Hint(TObject *Sender)
{
  StatusBar1->SimpleText=Application->Hint;
}
//---------------------------------------------------------------------------



void __fastcall TForm1::N2Click(TObject *Sender)
{
  my_raschet();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N12Click(TObject *Sender)
{
  my_raschet();
}
//---------------------------------------------------------------------------

void  my_refresh(void)
{
  Form1->Edit1->Text=FloatToStrF(id.V1,ffFixed,3,3);
  Form1->Edit2->Text=FloatToStrF(id.ni,ffFixed,3,3);
  Form1->Edit3->Text=FloatToStrF(id.krat,ffFixed,3,3);
  Form1->Edit4->Text=FloatToStrF(id.tH,ffFixed,3,3);
  Form1->Edit5->Text=FloatToStrF(id.TH,ffFixed,3,3);
  Form1->Edit6->Text=FloatToStrF(id.TK,ffFixed,3,3);
  Form1->Edit7->Text=FloatToStrF(id.P,ffFixed,10,3);
  Form1->Edit8->Text=FloatToStrF(id.dP[1],ffFixed,10,3);
  Form1->Edit9->Text=FloatToStrF(id.dP[2],ffFixed,10,3);
  Form1->Edit10->Text=FloatToStrF(id.delta[1],ffFixed,1,7);
  Form1->Edit11->Text=FloatToStrF(id.delta[2],ffFixed,1,7);
  Form1->Edit12->Text=FloatToStrF(id.K[2],ffFixed,5,3);
  Form1->Edit13->Text=FloatToStrF(id.K[1],ffFixed,5,3);
}
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  my_refresh();
  ComboBox1->ItemIndex=4;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit1KeyPress(TObject *Sender, char &Key)
{
  if((Key<'0' || Key>'9') && Key!=',' && Key!=8) {Key=0; return;}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit2KeyPress(TObject *Sender, char &Key)
{
  if((Key<'0' || Key>'9') && Key!=',' && Key!=8) {Key=0; return;}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit3KeyPress(TObject *Sender, char &Key)
{
  if((Key<'0' || Key>'9') && Key!=',' && Key!=8) {Key=0; return;}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit4KeyPress(TObject *Sender, char &Key)
{
  if((Key<'0' || Key>'9') && Key!=',' && Key!=8) {Key=0; return;}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit5KeyPress(TObject *Sender, char &Key)
{
  if((Key<'0' || Key>'9') && Key!=',' && Key!=8) {Key=0; return;}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit6KeyPress(TObject *Sender, char &Key)
{
  if((Key<'0' || Key>'9') && Key!=',' && Key!=8) {Key=0; return;}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit7KeyPress(TObject *Sender, char &Key)
{
  if((Key<'0' || Key>'9') && Key!=',' && Key!=8) {Key=0; return;}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit8KeyPress(TObject *Sender, char &Key)
{
  if((Key<'0' || Key>'9') && Key!=',' && Key!=8) {Key=0; return;}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit9KeyPress(TObject *Sender, char &Key)
{
  if((Key<'0' || Key>'9') && Key!=',' && Key!=8) {Key=0; return;}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit10KeyPress(TObject *Sender, char &Key)
{
  if((Key<'0' || Key>'9') && Key!=',' && Key!=8) {Key=0; return;}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit11KeyPress(TObject *Sender, char &Key)
{
  if((Key<'0' || Key>'9') && Key!=',' && Key!=8) {Key=0; return;}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit12KeyPress(TObject *Sender, char &Key)
{
    if((Key<'0' || Key>'9') && Key!=',' && Key!=8) {Key=0; return;}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit13KeyPress(TObject *Sender, char &Key)
{
    if((Key<'0' || Key>'9') && Key!=',' && Key!=8) {Key=0; return;}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N15Click(TObject *Sender)
{
 exit(0);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N3Click(TObject *Sender)
{
  my_load();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N5Click(TObject *Sender)
{
  my_save();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N4Click(TObject *Sender)
{
  if(SaveDialog2->Execute())
  {
    if((f=fopen(SaveDialog2->FileName.c_str(),"r"))!=NULL)
      if(Application->MessageBoxA("    !"
                                  "\n-  ()  ???",
                                  "       !",MB_YESNO)==IDNO)
                                  {fclose(f); return;}
    fclose(f);
  }
  Memo1->Lines->SaveToFile(SaveDialog2->FileName);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N8Click(TObject *Sender)
{
  my_about();
}
//---------------------------------------------------------------------------

void  my_about(void)
{
  Beep();
  Application->MessageBoxA(" :     -991 \n"
                           "                                  "
                           "       . .\n\n"
                           ":           \n"
                           "                                 "
                           "      . .\n\n\n"
                           "                     ()  2002",
                           "   :",MB_OK);
}
//---------------------------------------------------------------------------


void __fastcall TForm1::N14Click(TObject *Sender)
{
  my_about();
}
//---------------------------------------------------------------------------

void  my_save(void)
{
  if(Form1->SaveDialog1->Execute())
  {
    if((f=fopen(Form1->SaveDialog1->FileName.c_str(),"r"))!=NULL)
      if(Application->MessageBoxA("     !"
                                  "\n-  ()  ???",
                                  "       !",MB_YESNO)==IDNO)
                                  {fclose(f); return;}
    f=fopen(Form1->SaveDialog1->FileName.c_str(),"wb+");
    fwrite(&id,sizeof(struct dano),1,f);
    fclose(f);
  }
}
//---------------------------------------------------------------------------


void  my_load(void)
{
  if(Form1->OpenDialog1->Execute())
  {
    if((f=fopen(Form1->OpenDialog1->FileName.c_str(),"rb+"))==NULL)
    {
      Application->MessageBoxA("   !"
                               "\n,   "
                               "   .",
                               "       !  !",MB_OK);
      return;
    }
    fread(&id,sizeof(struct dano),1,f);
    fclose(f);
    my_refresh();
  }

}
void __fastcall TForm1::N10Click(TObject *Sender)
{
  my_load();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N9Click(TObject *Sender)
{
  my_save();        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N11Click(TObject *Sender)
{
  exit(0);
}
//---------------------------------------------------------------------------


void __fastcall TForm1::N13Click(TObject *Sender)
{
  my_raschet();
  Form1->WindowState=wsMinimized;
  Memo1->Lines->SaveToFile(SaveDialog2->FileName);
  ShellExecute(Handle,NULL,SaveDialog2->FileName.c_str(),NULL,NULL,SW_RESTORE);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N17Click(TObject *Sender)
{
  my_raschet();
}
//---------------------------------------------------------------------------



void __fastcall TForm1::N18Click(TObject *Sender)
{
  if(FontDialog1->Execute())
  {
    Memo1->Font=FontDialog1->Font;
  }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::SpeedButton1Click(TObject *Sender)
{
  GroupBox2->Visible=!GroupBox2->Visible;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::shemaClick(TObject *Sender)
{
  Memo1->Visible=false;
  GroupBox1->Visible=false;
  SpeedButton1->Visible=false;
  GroupBox2->Visible=false;
  Form1->WindowState=wsNormal;//wsMaximized;
  N17->Visible=false;
  Image1->Visible=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Image1Click(TObject *Sender)
{
  Memo1->Visible=false;
  GroupBox1->Visible=true;
  SpeedButton1->Visible=true;
  GroupBox2->Visible=false;
  Form1->WindowState=wsNormal;
  N17->Visible=true;
  N17->Caption="          !";
 Image1->Visible=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N7Click(TObject *Sender)
{
  TStringList *rez = new TStringList;
  AnsiString bufF=" F   ",bufN=" N   ",bufM=" M   ";
  rez->Add("-----------      -----------");
  rez->Add("---     (  15518-83)---");
  rez->Add("");
  rez->Add("   F (..),   N (.),"
           "    M ()");
  rez->Add("    f (..)");
  rez->Add("");
  for(int n=0;n<4;n++)
  {
    plast=GOST[n];
    rez->Add(" f="+FloatToStrF(plast.F1,ffFixed,7,1)+" ..");
    for(int i=0;i<15;i++)
    {
      if(plast.F[i]<1)break;
      bufF=bufF+FloatToStrF(plast.F[i],ffFixed,7,1)+"; ";
      bufN=bufN+FloatToStrF(plast.N[i],ffFixed,7,0)+"; ";
      bufM=bufM+FloatToStrF(plast.M[i],ffFixed,7,0)+"; ";
    }
    rez->Add(bufF);
    rez->Add(bufN);
    rez->Add(bufM);
    rez->Add("");
  }
  rez->Add("");
  rez->Add("    "
           " ");
  rez->Add("-----------------------------------------------");
  for(int n=0;n<4;n++)
  {
    plast=GOST[n];
    rez->Add(" :   "+FloatToStrF(plast.F1,ffFixed,7,1)+" ..");
    rez->Add("  :   "+FloatToStrF(plast.de,ffFixed,7,4)+" .");
    rez->Add("  :   "+FloatToStrF(plast.f1,ffFixed,7,5)+" ..");
    rez->Add("  :   "+FloatToStrF(plast.Lp,ffFixed,7,3)+" .");
    rez->Add("   :   "+FloatToStrF(plast.Du,ffFixed,7,3)+" ..");
    rez->Add("");
  }

  Form1->Memo1->Lines=rez;
  Memo1->Visible=!Memo1->Visible;
  N17->Visible=!N17->Visible;
}
//---------------------------------------------------------------------------
 
void __fastcall TForm1::Edit1Change(TObject *Sender)
{
  id.V1=my_input(Edit1,0.1,500);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit2Change(TObject *Sender)
{
  id.ni=my_input(Edit2,10,99);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit3Change(TObject *Sender)
{
  id.krat=my_input(Edit3,1,100);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit4Change(TObject *Sender)
{
  id.tH=my_input(Edit4,1,100);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit5Change(TObject *Sender)
{
  id.TH=my_input(Edit5,1,200);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit6Change(TObject *Sender)
{
  id.TK=my_input(Edit6,1,200);        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit7Change(TObject *Sender)
{
  id.P=my_input(Edit7,1,10000000);        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit8Change(TObject *Sender)
{
  id.dP[1]=my_input(Edit8,1,1000000);        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit9Change(TObject *Sender)
{
  id.dP[2]=my_input(Edit9,1,1000000);        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit10Change(TObject *Sender)
{
  id.delta[1]=my_input(Edit10,0,10);        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit11Change(TObject *Sender)
{
  id.delta[2]=my_input(Edit11,0,10);        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit12Change(TObject *Sender)
{
  id.K[2]=my_input(Edit12,10,10000);        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit13Change(TObject *Sender)
{
  id.K[1]=my_input(Edit13,10,10000);        
}
//---------------------------------------------------------------------------

